opencv3.1.0在ubutun14.04上编译出错问题

版权声明:本文为博主原创文章,遵循 CC 4.0 BY-SA 版权协议,转载请附上原文出处链接和本声明。
本文链接:https://blog.csdn.net/Hhrock/article/details/68945396
我在编译opencv的时候,总是出现这个错误:

[ 33%] Building CXX object modules/core/CMakeFiles/opencv_core.dir/src/rand.cpp.o
[ 33%] Building CXX object modules/core/CMakeFiles/opencv_core.dir/opencl_kernels_core.cpp.o
Linking CXX shared library ../../lib/libopencv_core.so
/usr/bin/ld: /usr/local/lib/libz.a(gzio.o):普通ELF重定位(M: 40)
/usr/bin/ld: /usr/local/lib/libz.a(gzio.o):普通ELF重定位(M: 40)
/usr/local/lib/libz.a: error adding symbols: 文件格式错误
collect2: error: ld returned 1 exit status
make[2]: *** [lib/libopencv_core.so.3.1.0] 错误 1
make[1]: *** [modules/core/CMakeFiles/opencv_core.dir/all] 错误 2
make: *** [all] 错误 2

在百度上查,没有结果难过
翻墙到谷歌上查,也没有合适的答案敲打
这个问题整整困了我一天也没有解决抓狂

最后只能硬着头皮继续查,按照报错的提示挨个查找关键字。
于是看到了libz.a的相关知识,内容如下:

Could not read symbols原因和解决方案

  1、 gcc/g++版本不正确
  众所周知Linux gcc编译器(GNU Compiler Collection)是功能强大的交叉编译器,但其众多的版本会导致兼容问题。如果联编所使用的 .a/.so文件是由另一个不同版本的gcc编译生成后,当移植到另一个不同版本gcc环境下编译时,(例如:将gcc2.9x老版本下的.so,拷贝入新版gcc环境使用),且编译版本不兼容,会出现Could not read symbols的报错。(可以使用gcc -v 查看一下当前版本)
  如果是这种原因导致的问题,需要在新gcc版本下,删除(或更名)旧的库文件,重新由src编译生成.a/.so文件,保证gcc版本一致

出处:http://blog.csdn.net/edonlii/article/details/8452262

根据上文的思路,我先是把lizb.a删除(/usr/local/lib/),然后删除整个opencv文件夹,重新解压,从头开始做。
我猜想应该是在cmake的时候重新生成了适合当前版本的lizb.a。
于是编译顺利通过。


展开阅读全文

没有更多推荐了,返回首页